import java.util.Scanner;
import java.util.Random;

public class Board {
    private static int solve(int [] positions_x, int [] positions_y) {

        /* ------------------- INSERT CODE HERE ---------------------*/

        // rows specified by postions_y
        int maxMem = 0;

        for(int r = 1; r <= 8; r++) {
        	int count = 0;
        	for(int i = 0; i < positions_y.length; i++) {
        		if (positions_y[i] == r)
        			count++;
        	}
        	if (count > maxMem)
        		maxMem = count;
        }

        /* -------------------- END OF INSERTION --------------------*/

        return maxMem;
    }

    private static void sanity(int[] positions_x, int[] positions_y) {
        boolean[][] used = new boolean[9][9];

        for(int ii = 0; ii < 9; ii++)
            for(int jj = 0; jj < 9; jj++)
                used[ii][jj] = false;

        for(int i = 0; i < positions_x.length; i++) {
            if(used[positions_x[i]][positions_y[i]]) {
                System.out.println("ERROR");
                System.exit(1);
            } else {
                used[positions_x[i]][positions_y[i]] = true;
            }
        }
    }



    private static void GenerateData() {
        Random rand = new Random(20);
        System.out.println(100);

        boolean[][] used = new boolean[9][9];

        for(int i = 0; i < 100; i++) {
            int numRooks = 1 + rand.nextInt(14);

            for(int ii = 0; ii < 9; ii++)
                for(int jj = 0; jj < 9; jj++)
                    used[ii][jj] = false;

            System.out.print(numRooks);

            while(numRooks > 0) {
                int x = 1 + rand.nextInt(8);
                int y = 1 + rand.nextInt(8);
                if(! used[x][y]) {
                    System.out.print(" " + x + " " + y);
                    used[x][y] = true;
                    numRooks--;
                }
            }
            System.out.println();
        }
    }


    public static void main(String[] args) {
        // GenerateData();
        
        Scanner sc = new Scanner(System.in);

        int numCases = sc.nextInt();

        for(int i = 0; i < numCases; i++) 
        {
            int numPieces = sc.nextInt();

            int[] positions_x = new int[numPieces];
            int[] positions_y = new int[numPieces];


            for(int j = 0; j < numPieces; j++) {
                positions_x[j] = sc.nextInt();
                positions_y[j] = sc.nextInt();
            }

            System.out.println (solve(positions_x, positions_y));

        }
    }
}

